function [ A, p,q ,wachs] = GaussTot( A )
	%Hier wird das maximale Element der Ursprungsmatrix gespeichert zwecks Wachstumsfaktor
	w0=max(max(abs(A)));
	%maximale Element der Zwischenmatrizen auf Anfangswert 0. Wird pro m-schleife berprft/neu gesetzt (siehe unten)
	wm=0;
	
	n = length( A ); %Dimension Matrix
	p = [1:n]; %Spaltenvertauschungs-Permutation. 1-2-3-... 1. 2 Spalten vertauscht -> 2-1-3-...
	q = [1:n]; %Zeilenvertauschungs-Permutation. Wie Spalten

	for m = 1:n
		
		%Pivotelementsuche
		piv = abs( A(m,m) ); %gesucht ist ein greres Element als das im Diagonaleintrag. Dieses wird unser Pivotelement.
		pivj = m; %die Ursprungs-Spalte des neuen Pivotelements wird zwischengespeichert, damit man Matrix und p besser ndern kann
		pivi = m; %Wie pivj, nur Ursprungs-Zeile
		%Da man Zeilen- und Spaltenvertauschen darf, suchen wir in allen Elementen, die rechts und unterhalb (auch selbe Zeile/Spalte) des Diagonalelements stehen nach greren Elementen (Betrag)
		%Die Elemente oberhalb oder links davon stehen wurden bereits behandelt und stehen der Pivotsuche nicht mehr zur Verfgung zum Vertauschen
		for j = m:n %Zeilen unterhalb einschl.
			for i=m:n %Spalten rechts einschl.
				if abs( A(j,i) ) > piv %Wenn Element grer als bisher grtes Pivot-Element...
					piv = abs( A(j,i) ); %Neues Pivot-Element
					pivj = j; %Merke Ursprungsspalte
					pivi=i; %Merke Ursprungszeile
				endif
			endfor
		endfor

		%Pivot-Vertauschung anwenden

		%tausche p(m) mit p(pivj), also tausche in der Permut.-Reihenfolge der Spalten die des aktuellen Diagonalelements mit der des gefundenen Pivot-Elements
		j = p( m ); %Dummy-Variable zum zwischenspeichern Diagonalel.Spalte
		p( m ) = p( pivj ); %berschreibe Spalten-Position Diag.El. mit Sp.Pos. Pivot.El
		p( pivj ) = j; %Stelle Sp.Pos Diag.El an der Stele von Pivot.El wieder her
		
		xj = A( m,: );A( m,: ) = A( pivj,: ); A( pivj,: ) = xj; %Analog Tausch p(m) p(pivj), jedoch werden hier die Spalten der Matrix getauscht
		
		i = q( m ); q( m ) = q( pivi ); q( pivi ) = i; %Analog obiger Tausch, hier Permutations Zeile
		
		xi = A( :,m); A( :,m ) = A( :,pivi); A(:, pivi ) = xi; %Analog obiger Tausch, hier Zeilen der Matrix

		%Elimination der Transformierten (Zeilen/Spalten-Tausch, damit in aktuellen Diagonalelement mglichst maximale Zahl) Matrix
		
		w = A( m,m+1:n ); %aktuelle Spalte nach (unter) Diag.El wird zwischengespeichert, da nach Teilen durch das Diag.El jeder Zeile noch bentigt
		for j = m+1:n %Alle Zeilen
			A( j,m ) = A( j,m ) / A( m,m ); %Teile Zeilen durch Diag.El
			A( j,m+1:n ) = A( j,m+1:n ) - A( j,m ) * w; %Ziehe von jeder Zeile jeweils ein Vielfaches der Zeilen hinter dem Diagel ab, das dem Eintrag unter diesem entspricht. Nach Gau wird dieser Eintrag so Eliminiert
		endfor

		wp=max(max(abs(A))); %Nach der Elimination betrachten wir wieder das maximale Element (Betrag) der Matrix zwecks Wachstumsfaktor
		if wp>wm %Ist das maximale Element dieser Matrix grer als alle bisherigen maximalen Elemente der Vorgngermatrizen...
			wm=wp; %wird dieses nun zwischengespeichert
		endif

	endfor
	wachs=wm/w0; %Wachstumsfaktor=maximales maximales Element (Betrag) aller Zwischenmatrizen in der Gau-Elimination / maximales Element (Betrag) Urspungsmatrix
endfunction

%Berechnet Gau-Transformation mittels TotalPivotSuche und gibt zustzlich die Permutationen (Spalte/Zeile) und den Wachstumsfaktor aus